<!DOCTYPE html>

<html>
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>File Encoder Example</title>
  <style type="text/css">
    ul { list-style: none; }
    li { margin: 1em; }
    audio { display: block; }
  </style>
</head>
<body>
  <h1>File Encoder Example</h1>
  <p>Choose a 16bit monophonic Wave file from disk.</p>
  <p>File is encoded from pcm to ogg</p>

  <h2>Options</h2>

  <div>
    <label>File Input sample rate (smp/sec)</label>
    <input id="sampleRate" type="number" value="44100" min="0" />
  </div>
  
  <div>
    <label>Resample Quality</label>
    <input id="resampleQuality" type="number" value="3" min="0" max="10" />
  </div>  

  <div>
    <label>Encoder Complexity</label>
    <input id="encoderComplexity" type="number" value="9" min="0" max="10" />
  </div>  

  <h2>Commands</h2>
  <input type="file" id="fileInput"/>

  <h2>Recordings</h2>
  <ul id="recordingslist"></ul>

  <script>
    var completeOggData = new Uint8Array(0);
   
    function concatUint8Arrays(a, b) {
      var c = new Uint8Array(a.length + b.length);
      c.set(a);
      c.set(b, a.length);
      return c;
    }

    function chunkBuffers(arrayBuffer, chunkLength){
      var chunkedBuffers = [];

      var totalFile = new Int16Array(arrayBuffer);
      // Skip wave header; 44 bytes
      for (i = 22; i < totalFile.length; i += chunkLength) {

        // Convert 16 bit signed int to 32bit float
        var bufferChunk = new Float32Array(chunkLength);
        for (j = 0 ; j < chunkLength ; j++) {
          bufferChunk[j] = (totalFile[i + j]+ 0.5) / 32767.5;
        }

        chunkedBuffers.push([bufferChunk]) ;
      };

      return chunkedBuffers 
    };
    
    function encodeOgg(arrayBuffer){
      var encoderWorker = new Worker('dist/encoderWorker.min.js');
      var bufferLength = 4096;
      
      encoderWorker.postMessage({
        command:            'init',
        encoderSampleRate:  48000,
        bufferLength:       bufferLength,
        originalSampleRate: parseInt(sampleRate.value,10),
        encoderApplication: 2049,
        encoderComplexity:  parseInt(encoderComplexity.value,10),
        resampleQuality:    parseInt(resampleQuality.value,10),
        numberOfChannels:   1
      });
      
      encoderWorker.postMessage({ 
        command:'getHeaderPages'
      });

      chunkBuffers(arrayBuffer, bufferLength).forEach(bufferChunk => encoderWorker.postMessage({
        command:'encode',
        buffers: bufferChunk
      }));

      encoderWorker.postMessage({
        command:'done'
      });

      encoderWorker.onmessage = ({ data }) => {
        if (data.message === "done") {
          //finished encoding - save to audio tag
          var fileName = new Date().toISOString() + ".ogg";        
          var dataBlob = new Blob( [ completeOggData ], { type: "audio/ogg" } );
          var url = URL.createObjectURL( dataBlob );

          var audio = document.createElement('audio');
          audio.controls = true;
          audio.src = URL.createObjectURL( dataBlob );

          var link = document.createElement('a');
          link.href = url;
          link.download = fileName;
          link.innerHTML = link.download;

          var li = document.createElement('li');
          li.appendChild(link);
          li.appendChild(audio);

          recordingslist.appendChild(li);
        }

        else if (data.message === "page") {
          completeOggData = concatUint8Arrays(completeOggData, data.page);
        }
      };
    };

    fileInput.onchange = function(e){
      var fileReader = new FileReader();

      fileReader.onload = function() {
        encodeOgg(this.result);
      };

      fileReader.readAsArrayBuffer( e.target.files[0] );
    };

  </script>
</body>
</html>
